<template lang="pug">
  div.column.justify-center.items-center.full-width
    span.text-h3.q-pb-xl Cadastro de Usuário
    div.column
      q-input(color="black" bg-color="white" outlined v-model="nome" label="Nome").q-py-xs
      q-input(
        color="black"
        bg-color="white" 
        outlined
        :value="dataNascimento"
        label="Data Nascimento"
        @click="$refs.qDateProxy.show()"
      ).q-py-xs
        template(v-slot:append)
          q-popup-proxy(ref="qDateProxy" transition-show="scale" transition-hide="scale")
            q-date(
              mask="DD/MM/YYYY"
              v-model="dataNascimento"
              default-view="Years"
              @input="$refs.qDateProxy.hide()"
            )
              div(class="row items-center justify-end")
                q-btn(v-close-popup label="Close" color="primary" flat)
      q-input(color="black" bg-color="white" outlined v-model="email" label="E-mail").q-py-xs
      q-input(color="black" bg-color="white" outlined v-model="username" label="Username").q-py-xs
      q-input(color="black" bg-color="white" outlined type='password' v-model="senha" label="Senha").q-py-xs
      q-input(color="black" bg-color="white" outlined type='password' v-model="confirmarSenha" label="Confirmar Senha").q-py-xs
      q-btn(v-if="!loading" color="secondary" text-color="white" glossy label="Cadastrar" @click="cadastrar()").q-my-xl
      q-spinner-tail(v-else color="secondary" size="6em").self-center

</template>

<script>
import { mapActions } from 'vuex'
import { QInput, QDate, QField, QSpinnerTail} from 'quasar'

export default {
  name: 'CamposCadastro',
  components: {
    QField,
    QInput,
    QDate,
    QSpinnerTail
  },
  data () {
    return {
      loading: false,
      nome: '',
      email: '',
      username: '',
      dataNascimento: '',
      senha: '',
      confirmarSenha: ''
    }
  },
  computed: {
    emailCorreto () {
      let re = new RegExp("[A-Za-z0-9]+@[A-Za-z0-9]+.[A-Za-z0-9]+");
      return re.test(this.email)
    },
    senhaTamanho () {
      return this.senha.trim().length > 6
    },
    senhaConfirmada () {
      return this.senha === this.confirmarSenha
    },
    camposObrigatorios () {
      return this.email.trim() !==  '' &&
        this.username.trim() !== '' &&
        this.nome.trim() !== '' &&
        this.dataNascimento.trim() !== '' &&
        this.senha.trim() !== ''
    }
    // todayDate () {
    //   var date = new Date()
    //   return `${date.getFullYear()}/${date.getMonth()}`
    // }
  },
  methods: {
    ...mapActions( 'user', [
      'cadastro'
    ]),
    async cadastrar () {
      this.loading = true
      if (!this.camposObrigatorios) {
        this.$q.notify({
          type: 'negative',
          message: `Campos obrigatórios não foram preenchidos`
        })
      } else if (!this.emailCorreto) {
        this.$q.notify({
          type: 'negative',
          message: `Email no formato incorreto`
        })
      } else if (!this.senhaConfirmada){
        this.$q.notify({
          type: 'negative',
          message: `Senhas não são iguais`
        })
      } else if (!this.senhaTamanho) {
       this.$q.notify({
          type: 'negative',
          message: `Senhas deve, no mínimo, 7 caracteres`
        }) 
      } else {
        await this.cadastro({email: this.email, senha: this.senha, nome: this.nome, username: this.username, dataNascimento: this.dataNascimento})
      }
      this.loading = false
    }
  }
}
</script>

<style lang="stylus">
.q-field__inner
  padding 0
</style>